'''
Created on 09/06/2014

@author: Adriana
'''

import matplotlib.pyplot as plt
import numpy as np
import sys
import csv
from numpy import genfromtxt 
import os 
import math 
import scipy as sp
from scipy import interpolate
from scipy.interpolate import griddata
from matplotlib import cm


class getOptimumValues():
    def handy(self,results):
        #This creates a dictionary in which the keys are the flows 
        #and the data related to each key is an array 
        #that contains all the results (optimum values) obtained with that flow
        #with different methane compositions
        d1= np.unique(results[:,2])
        d2= np.unique(results[:,3])
        #print "d1", d1
        num1=np.size(d1)
        num2=np.size(d2)
        print "num1, size d1- flow", num1
        print "num2, size d2- composition", num2
        for i in range (num1):
            if np.isnan(d1[i]):
                np.delete(d1,i)
                
        d1Optimum = { "%.0f" % d1[i] : self.do_something(i) for i in range(0,int(num1)) }
        keys = d1Optimum.keys()
        keys.sort()
       # for x in keys:
       #     print x, '=', d1Optimum[x]
        
        return d1Optimum
    
    def do_something(self, i):
        
        d1= np.unique(results[:,2])
        rowsResults=len(results)
        #print "rowsResults", rowsResults
        optimum=[]    
        for j in range (0,rowsResults):
            #if the flow is the flow that we want to get
            if  results[j, 2]== d1[i]:
                optimum= np.hstack((optimum,results[j, 4]))
         
        return optimum
    
    def handy_d2(self,results):
        #This creates a dictionary in which the keys are the flows 
        #and the data related to each key is an array 
        #that contains all the results (optimum values) obtained with that flow
        #with different methane compositions
        d1= np.unique(results[:,2])
        d2= np.unique(results[:,3])
        #print "d1", d1
        num1=np.size(d1)
        num2=np.size(d2)
        print "num1, size d1- flow", num1
        print "num2, size d2- composition", num2
        for i in range (num1):
            if np.isnan(d1[i]):
                np.delete(d1,i)
                
        d2_2plot = { "%.0f" % d1[i] : self.do_something_d2(i) for i in range(0,int(num1)) }
        keys2 =  d2_2plot.keys()
        keys2.sort()
        for x in keys2:
            print x, '=', d2_2plot[x]
        
        return d2_2plot
        
    def do_something_d2(self, i):
        
        d1= np.unique(results[:,2])
        rowsResults=len(results)
        #print "rowsResults", rowsResults
        d2plot=[]    
        for j in range (0,rowsResults):
            #if the flow is the flow that we want to get
            if  results[j, 2]== d1[i]:
                d2plot= np.hstack((d2plot,results[j, 3]))
         
        return d2plot

def unique_rows(data):
    uniq = np.unique(data.view(data.dtype.descr * data.shape[1]))
    return uniq.view(data.dtype).reshape(-1, data.shape[1])

if __name__ == '__main__':

    results = genfromtxt('aResultsforconstraintareas.csv', delimiter=',')
    results2 = genfromtxt('Results463manipaddedmodified.csv', delimiter=',')
    results3 = genfromtxt('Results_re_run2nd_part.csv', delimiter=',')
    
    for i in range (len(results)):
        if np.isnan(results[i,0]):
            np.delete(results,i,0)   
    
    d1init=0.9
    d1fin=1.05
    d2init=0.9
    d2fin=1.1
    
    d1= np.unique(results[:,2])
    d2= np.unique(results[:,3])
    print "d2.size", np.size(d2)
    
    
    sizeResults=np.size(results)
    rowsResults=np.size(results,0)
    columnsResults=np.size(results,1)
    
    num=np.size(d1)
           
    d1Optimum=getOptimumValues().handy(results)
    d2PlotOptimum=getOptimumValues().handy_d2(results)
    
    d1OptimumKeys=sorted(d1Optimum)
    d2PlotOptimumKeys=sorted(d2PlotOptimum)

    plt.figure(1)
    ax = plt.subplot(111)
    
    for i in xrange(num-1):
        ax.plot(d2PlotOptimum[d2PlotOptimumKeys[i]], -1*d1Optimum[d1OptimumKeys[i]], label=d1OptimumKeys[i], marker='o')
    
    plt.xlabel('$CH_4$ mol composition')
    plt.ylabel('Profit [$/h]')
    plt.axis([np.min(d2)-(d2[1]-d2[0]), np.max(d2)+(d2[1]-d2[0]),-1*(np.max(results[:,4])+0.1*(np.max(results[:,4])-np.min(results[:,4]))), -1*(np.min(results[:,4])-0.1*(np.max(results[:,4])-np.min(results[:,4])))])
    plt.grid(True)
    
    box = ax.get_position()
    ax.set_position([box.x0, box.y0 + box.height * 0.1,
                 box.width, box.height * 0.9])
    # Put a legend below current axis
    leg=ax.legend(loc='upper center', bbox_to_anchor=(0.5, -0.1),
         fancybox=True, shadow=True, ncol=12,title="make-up flow [kmol/h]", fontsize=8)
    
    leg.get_frame().set_alpha(0.5)
    plt.savefig('optimumvsdisturbances.eps', format='eps', dpi=1000, transparent=True)
    
    
    #Identify active constraint regions
    boundedMax=0.999
    boundedMin=0.001
    boundIneq=-0.001
    activeConstr=np.zeros((int(rowsResults),12))
    
    for i in range (0,int(rowsResults)):
        if results[i,12]>boundedMax:
            activeConstr[i,0]=1
        elif results[i,12]<boundedMin:
            activeConstr[i,1]=1    
        if results[i,13]>boundedMax:
            activeConstr[i,2]=1
        elif results[i,13]<boundedMin:
            activeConstr[i,3]=1
        if results[i,14]>boundedMax:
            activeConstr[i,4]=1
        elif results[i,14]<boundedMin:
            activeConstr[i,5]=1    
        if results[i,15]>boundedMax:
            activeConstr[i,6]=1
        elif results[i,15]<boundedMin:
            activeConstr[i,7]=1
        if results[i,16]> boundIneq:
            activeConstr[i,8]=1
        if results[i,17]> boundIneq:
            activeConstr[i,9]=1
        if results[i,18]> boundIneq:
            activeConstr[i,10]=1             
        if results[i,19]> boundIneq:
            activeConstr[i,11]=1
            
    
    #print"activeConstr", activeConstr
    constrRegions = unique_rows(activeConstr)
    print "constraint regions=", constrRegions
    
    #number of constraint regions
    numConstrRegions=np.size(constrRegions,0)
    print "number of constraint regions", numConstrRegions
    
    #Construct an array with three columns: flow, composition, active constraint
    plotConstrRegions=np.zeros((int(rowsResults),3))
    for i in range (0,int(rowsResults)):
        plotConstrRegions[i,0]=results[i,2]
        plotConstrRegions[i,1]=results[i,3]
        for j in range (0,int(numConstrRegions)):
            if np.array_equal(activeConstr[i,:],constrRegions[j,:]):
                plotConstrRegions[i,2]=j+1
      
    #Associate regions with colors; five constraint regions
    #Color palette taken from http://colorbrewer2.org/#
   
    
    rgbColors2=list()
    #This variable should be called hexColors; hexadecimal color notation was used :)
    #Possible improvement for code: create array with color coding; 
    #something like colors=['#e41a1c', '#4daf4a',...]
    #for easier manipulation; and to eliminate requirement of re-writing colors. 
    
    elementsRegions=np.zeros(numConstrRegions)
    
    region1=[]
    region2=[]
    region3=[]
    region4=[]
    region5=[]
    region6=[]
    region7=[]
    region8=[]
        
    for i in range (0,int(rowsResults)):
        if plotConstrRegions[i,2]==1:
            rgbColors2.append('#e41a1c')
            elementsRegions[0]+=1
            region1= np.hstack((region1,i))
        elif plotConstrRegions[i,2]==2:     
            rgbColors2.append('#4daf4a')
            elementsRegions[1]+=1
            region2= np.hstack((region2,i))
        elif plotConstrRegions[i,2]==3:     
            rgbColors2.append('#377eb8')
            elementsRegions[2]+=1  
            region3= np.hstack((region3,i))        
        elif plotConstrRegions[i,2]==4:     
            rgbColors2.append('#984ea3')
            elementsRegions[3]+=1
            region4= np.hstack((region4,i))
        elif plotConstrRegions[i,2]==5:     
            rgbColors2.append('#ff7f00')
            elementsRegions[4]+=1
            region5= np.hstack((region5,i))
        elif plotConstrRegions[i,2]==6:     
            rgbColors2.append('#ffff33')
            elementsRegions[5]+=1
            region6= np.hstack((region6,i))
        elif plotConstrRegions[i,2]==7:     
            rgbColors2.append('#a65628')
            elementsRegions[6]+=1
            region7= np.hstack((region7,i))
        elif plotConstrRegions[i,2]==8:     
            rgbColors2.append('#f781bf')
            elementsRegions[7]+=1
            region8= np.hstack((region8,i))
        elif plotConstrRegions[i,2]==9:     
            rgbColors2.append('#999999')
            elementsRegions[8]+=1
    
    print "elementsRegions", elementsRegions
    print "region1:", region1
    print "region2:", region2
    print "region3:", region3
    print "region4:", region4
    print "region5:", region5
    print "region6:", region6
    print "region7:", region7
    print "region8:", region8
                  
    regionNames= []
    for i in range(numConstrRegions):
        regionNames=np.hstack((regionNames,str(i+1)))
    
    p1 = plt.Rectangle((0, 0), 1, 1, fc="#e41a1c")    
    p2 = plt.Rectangle((0, 0), 1, 1, fc="#4daf4a") 
    p3 = plt.Rectangle((0, 0), 1, 1, fc="#377eb8") 
    p4 = plt.Rectangle((0, 0), 1, 1, fc="#984ea3") 
    p5 = plt.Rectangle((0, 0), 1, 1, fc="#ff7f00") 
    p6 = plt.Rectangle((0, 0), 1, 1, fc="#ffff33") 
    p7 = plt.Rectangle((0, 0), 1, 1, fc="#a65628") 
    p8 = plt.Rectangle((0, 0), 1, 1, fc="#f781bf") 
    
    p=[p1,p2,p3,p4,p5,p6,p7,p8]
    
    plt.figure(2)
    ax = plt.subplot(111)
    plt.scatter(plotConstrRegions[:,1], plotConstrRegions[:,0], s=20*np.pi*np.ones(rowsResults), color=rgbColors2, alpha=0.8, marker="s")
    plt.xlabel('$CH_4$ mol composition')
    plt.ylabel('Syngas make-up flow [kmol/h]')
    plt.axis([np.min(d2)-(d2[1]-d2[0]), np.max(d2)+(d2[1]-d2[0]),np.min(d1)-(d1[1]-d1[0]), np.max(d1)+(d1[1]-d1[0])])
        
    box = ax.get_position()
    ax.set_position([box.x0, box.y0 + box.height * 0.1,
                 box.width, box.height * 0.9])
    
    # Put a legend below current axis
    leg=ax.legend(p,regionNames, loc='upper center', bbox_to_anchor=(0.5, -0.1),
         fancybox=True, shadow=True, ncol=10,title="Regions", fontsize=8)
    
    leg.get_frame().set_alpha(0.5)
    
    plt.savefig('constraintRegions.eps', format='eps', dpi=1000, transparent=True)
    
   
    plt.figure(3)
    #time for optimization
    timeRun= results[:,5]
    plt.hist(timeRun, bins=20)
    plt.xlabel("Time to solve optimization [s]")
    plt.ylabel("Frequency")
    plt.savefig('runningTime.eps', format='eps', dpi=1000, transparent=True)
    
    plt.figure(4)
    #function evaluations
    fnEvaluations= results[:,7]
    plt.hist(fnEvaluations, bins=15, normed=False)
    plt.xlabel("Number of function evaluations")
    plt.ylabel("Frequency")
    plt.savefig('numEvaluations.eps', format='eps', dpi=1000, transparent=True)
    
    plt.figure(5)
    #needs two results to compare
    fneval1=results2[:,7]
    fneval2=results3[:,7]
    plt.hist([fneval1, fneval2], bins=40, normed=False, label=['$10^{-6}$', '$10^{-8}$'])
    plt.axvline(fneval1.mean(), color='c', linestyle='dashed', linewidth=2)
    plt.axvline(fneval2.mean(), color='y', linestyle='dashed', linewidth=2)
    plt.legend(fancybox=True, shadow=True, ncol=10,title="Tolerance")
    plt.xlabel("Number of function evaluations")
    plt.ylabel("Frequency")
     
    plt.show()