'''
Created on 13/06/2014

@author: Adriana
'''

if __name__ == '__main__':
    from mpl_toolkits.mplot3d import axes3d
    import matplotlib.pyplot as plt
    import numpy as np

    from matplotlib import cm
    from numpy import genfromtxt 
    
    #read file
    results = genfromtxt('Resultsforconstraintareas.csv', delimiter=',')
    #read flows and extract unique values 
    d1= np.unique(results[:,2])
    #read concentrations and extract unique values
    d2= np.unique(results[:,3])
    
    #re arrange data 
    lats = results[:,2] 
    lons = results[:,3]  
    values = -1*results[:,4]
    lat_uniq = list(set(lats.tolist())) 
    nlats = len(lat_uniq) 
    lon_uniq = list(set(lons.tolist())) 
    nlons = len(lon_uniq) 
    color_map = cm.spectral 
    print lats.shape, nlats, nlons 
    yre = lats.reshape(nlats,nlons) 
    xre = lons.reshape(nlats,nlons) 
    zre = values.reshape(nlats,nlons)
    
    #Generate 2D contour plot
    plt.figure(1) 
    CS = plt.contour(xre, yre, zre, cmap=color_map) 
    plt.clabel(CS, inline=1, fontsize=10, fmt='%1.0f')
    plt.xlabel("$CH_4$ mole concentration")
    plt.ylabel("Syngas make-up flow [kmol/h]")
    plt.savefig('contourPlot.eps', format='eps', dpi=1000, transparent=True)

    #Generate 3D plot
    fig=plt.figure(2)
    ax = fig.gca(projection='3d')

    ax.plot_surface(xre, yre, zre, rstride=8, cstride=8, alpha=0.3)
    cset = ax.contourf(xre, yre, zre, zdir='z', offset=-100, cmap=plt.cm.prism)
    cset = ax.contourf(xre, yre, zre, zdir='x', offset=-40, cmap=plt.cm.prism)
    cset = ax.contourf(xre, yre, zre, zdir='y', offset=40, cmap=plt.cm.prism)
    ax.set_xlabel('$CH_4$ mole concentration')
    ax.set_ylabel('Syngas make-up flow [kmol/h]')
    ax.set_zlabel('Profit [$/h]')
    plt.savefig('contourPlot3D.eps', format='eps', dpi=1000, transparent=True)

    plt.show()