'''
Created on Apr 23, 2014

@author: vladimim
'''
#Modified by Adriana Reyes to:
#Read and set parameters - disturbances (using Unisim2py)
#Read measurements
#Iterate over parameters
#SOME FUNCTIONS THAT ARE ON THE ORIGINAL CODE BY VLADIMIM 
#HAVE BEEN REMOVED BECAUSE THEY WERE NOT USED FOR THE THESIS

import nlopt
import time
import numpy as np
from Unisim1 import Unisim2py
import csv

def objFunc(x, grad):
    global counter
    global beginIter

    Jterms = unisim1.getObjectiveFunctionTerms
    J = lambda x: sum(Jterms(x))
    if grad.size > 0:
        getGradient(J, x, grad)
    counter += 1

    return J(x)


def optimizationBOBYQA():

   # import information from the Unisim
    lb = np.array(unisim1.getLowerBounds(scaled=True))
    print "scaled lb:", lb
    ub = np.array(unisim1.getUpperBounds(scaled=True))
    print "scaled ub:",ub
    x0 = np.array(unisim1.getInitialInputValues(scaled=True))
    print "x0", x0


    # Construct nlopt opt object
    opt = nlopt.opt(nlopt.LN_BOBYQA, unisim1.numberOfInputs)
    # Set the bounds
    opt.set_lower_bounds(lb)
    opt.set_upper_bounds(ub)
    # Specify the objective function
    opt.set_min_objective(objFunc)
    # Maximum number of evaluations
    opt.set_maxeval(2000)
    # Tolerance
    opt.set_xtol_rel(1e-8)

    start = time.time()
    
    x = opt.optimize(x0)
               
    end = time.time()

    print "The assignment took", end-start, "seconds."

    print "Algorithm: ", opt.get_algorithm_name()
    print "Optimum at ", x
    print "Output inequality constraints:", unisim1.getInequalityConstraintValues()
    print "Output equality constraints:", unisim1.getEqualityConstraintValues()
    print "Disturbances: ", unisim1.getParametersValues()
    print "Minimum value = ", opt.last_optimum_value()
    print "Result code = ", opt.last_optimize_result()
    if opt.last_optimize_result()>0:
        print "nlopt Successful termination"
    else:
        print "Check: http://ab-initio.mit.edu/wiki/index.php/NLopt_Reference#Return_values"
    print "Function evaluations = ", counter
    print "\n"
    
    soln.append(opt.last_optimum_value())
    runTime.append(end-start)
    resultCode.append(opt.last_optimize_result())
    evaluations.append(counter)
    inputConstr.append(x)
    outputConstr.append(unisim1.getInequalityConstraintValues())


if __name__ == '__main__':

    unisim1 = Unisim2py()
    
    global soln
    global runTime
    global resultCode
    global evaluations
    global inputConstr
    global outputConstr
    
    #global solni
    #global runTimei
    #global resultCodei
    #global evaluationsi
    #global inputConstri
    #global outputConstri  
    
    global writer 
    global i
    global j
    
    #Definition of number of steps
    step=0.01
    #For i (flow)
    resinit=0.983333333
    resfin=1.2
    #for j (composition)
    res1init=0.9
    res1fin=1.0
    
    #if you want to read the values for iteration from a file
    flow = genfromtxt('Flows.csv', delimiter=',')
    res=np.linspace(resinit,resfin,(resfin-resinit)/step+1)
    res1=np.linspace(res1init,res1fin,(res1fin-res1init)/step+1)
    
    soln=[]
    runTime=[]
    resultCode=[]
    evaluations=[]
    inputConstr=[]
    outputConstr=[]

    point= 0
    
    f = open('Results_lowtol_lowconc.csv', 'wb')
    fieldnames = ('Flow_j', 'Comp_j','Flow', 'Comp', 'Soln', 'Time','Code','Evaluations','Input1','Input2','Input3','Input4','Input1sc','Input2sc','Input3sc','Input4sc','Output1','Output2','Output3','Output4','Meas1','Meas2','Meas3','Meas4','Meas5','Meas6','Meas7','Meas8','Meas9','Meas10','Meas11')
    writer = csv.DictWriter(f,fieldnames=fieldnames, restval='missing')
    
    for i in flow:
        for j in res1:
            
            counter = 0
    
            lb = np.array(unisim1.getLowerBounds(scaled=True))
            print lb
            ub = np.array(unisim1.getUpperBounds(scaled=True))
            print ub
            x0 = np.array(unisim1.getInitialInputValues(scaled=True))
            print x0
    
            #set disturbances
            #dnom=np.array([2.e4, 0.01])
            dnom=np.array([1, 0.01])
            var=np.array([i, j])
            d=var*dnom
            print "d=",d
            unisim1.setParametersValues(d)

            print unisim1.hyFlowsheet.Operations.Item("Objective").Cell("A{0}".format(3)).CellVariable.Value
            print unisim1.hyFlowsheet.Operations.Item("Objective").Cell("A{0}".format(3)).CellVariable.IsKnown
            print unisim1.hyFlowsheet.Operations.Item("Objective").Cell("A{0}".format(3)).CellVariable.IsValid

            unisim1.isObjectiveMultiTerm = False
            unisim1.printNLP()
            
            try:
                optimizationBOBYQA()
            
                inputConstr2=np.asarray(inputConstr)
                outputConstr2=np.asarray(outputConstr)
                
                x=unisim1.getInputsValues(scaled=False)
                print "Inputs", x
                
                y= unisim1.getMeasurementsValues()
                            
                writer.writerow({ 'Flow_j':i,
                                     'Comp_j':j,
                                     'Flow':d[0],
                                     'Comp':d[1],
                                     'Soln':soln[point],
                                     'Time':runTime[point],
                                     'Code':resultCode[point],
                                     'Evaluations':evaluations[point],
                                     'Input1':x[0],
                                     'Input2':x[1],
                                     'Input3':x[2],
                                     'Input4':x[3],                                    
                                     'Input1sc':inputConstr2.item((point, 0)),
                                     'Input2sc':inputConstr2.item((point, 1)),
                                     'Input3sc':inputConstr2.item((point, 2)),
                                     'Input4sc':inputConstr2.item((point, 3)),
                                     'Output1':outputConstr2.item((point, 0)),
                                     'Output2':outputConstr2.item((point, 1)),
                                     'Output3':outputConstr2.item((point, 2)),
                                     'Output4':outputConstr2.item((point, 3)),
                                     'Meas1':y[0],
                                     'Meas2':y[1],
                                     'Meas3':y[2],
                                     'Meas4':y[3],
                                     'Meas5':y[4],
                                     'Meas6':y[5],
                                     'Meas7':y[6],
                                     'Meas8':y[7],
                                     'Meas9':y[8],
                                     'Meas10':y[9],
                                     'Meas11':y[10],
                                     })
                
            
            except nlopt.roundoff_limited as e:
                print e
            point += 1