'''
Created on 11/06/2014

@author: Adriana
'''

import matplotlib.pyplot as plt
import numpy as np
import sys
import csv
from numpy import genfromtxt 
import os 
import math 
    
def extractData(data):

    extracted=[]
    
    for i in range(1,len(data)):
        # if it is a not even position
        #save it
        #values were saved in even positions
        if i%2!=0:
            extracted= np.hstack((extracted,data[i]))
    return extracted

if __name__ == '__main__':
    pass
    matlabData = genfromtxt('MatlabNominalSteps.csv', delimiter=',')
    dataGoodStart = genfromtxt('CH4nominal_goodStart.csv', delimiter=',')
    dataFarStart = genfromtxt('CH4nominal_farStart.csv', delimiter=',')
    dataFarStartLowTol = genfromtxt('CH4nominal_farStart_lowTol.csv', delimiter=',')
          
    dataGoodStart1=extractData(dataGoodStart)
    dataFarStart1=extractData(dataFarStart)
    dataFarStartLowTol1=extractData(dataFarStartLowTol)
    
    plt.figure(1)
    ax = plt.subplot(111)
    ax.plot(np.arange(len(dataGoodStart1)), -1*dataGoodStart1, 'r--', np.arange(len(dataFarStart1)), -1*dataFarStart1, 'ms', np.arange(len(dataFarStartLowTol1)), -1*dataFarStartLowTol1, 'c+', 9*np.arange(len(matlabData)), -1*matlabData, 'y*')
    plt.axis([0,350,11500,13500])
    plt.grid(True)
    
    box = ax.get_position()
    ax.set_position([box.x0, box.y0 + box.height * 0.1,
                 box.width, box.height * 0.9])
    leg=ax.legend(('gradient-free; close', 'gradient-free; far', 'gradient-free; far initial, low tolerance', 'gradient-based; far'),loc='upper center', bbox_to_anchor=(0.5, -0.1),
         fancybox=True, shadow=True, ncol=4,title="Algorithm type/Initial values", fontsize=10)
    
    leg.get_frame().set_alpha(0.5)
    
    plt.xlabel('Function evaluations')
    plt.ylabel('Profit [$/h]')
    plt.show()
    